<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>ServerEventService - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="HttpQuery.html">HttpQuery</a><ul class='methods'><li data-type='method' style='display: none;'><a href="HttpQuery.html#send">send</a></li></ul></li><li><a href="HttpQueryService.html">HttpQueryService</a></li><li><a href="PersistantData.html">PersistantData</a><ul class='methods'><li data-type='method' style='display: none;'><a href="PersistantData.html#loadJSON">loadJSON</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#saveJSON">saveJSON</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#list">list</a></li><li data-type='method' style='display: none;'><a href="PersistantData.html#getNewID">getNewID</a></li></ul></li><li><a href="PersistantDataService.html">PersistantDataService</a><ul class='methods'><li data-type='method' style='display: none;'><a href="PersistantDataService.html#~getQuery">getQuery</a></li><li data-type='method' style='display: none;'><a href="PersistantDataService.html#~getNewId">getNewId</a></li></ul></li><li><a href="RemanentForm.html">RemanentForm</a><ul class='methods'><li data-type='method' style='display: none;'><a href="RemanentForm.html#load">load</a></li></ul></li><li><a href="ServerEvent.html">ServerEvent</a><ul class='methods'><li data-type='method' style='display: none;'><a href="ServerEvent.html#onEvent">onEvent</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#isPending">isPending</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ServerEvent.html#addClock">addClock</a></li></ul></li><li><a href="ServerEventService.html">ServerEventService</a><ul class='methods'><li data-type='method' style='display: none;'><a href="ServerEventService.html#~doQuery">doQuery</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#add">add</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#clear">clear</a></li><li data-type='method' style='display: none;'><a href="ServerEventService.html#addClock">addClock</a></li></ul></li><li><a href="StopService.html">StopService</a></li><li><a href="UploadService.html">UploadService</a></li><li><a href="WrapperCC.html">WrapperCC</a><ul class='methods'><li data-type='method' style='display: none;'><a href="WrapperCC.html#call">call</a></li></ul></li><li><a href="WrapperCCService.html">WrapperCCService</a></li><li><a href="cookies.html">cookies</a><ul class='methods'><li data-type='method' style='display: none;'><a href="cookies.html#.get">get</a></li><li data-type='method' style='display: none;'><a href="cookies.html#.set">set</a></li></ul></li><li><a href="slugstring.html">slugstring</a><ul class='methods'><li data-type='method' style='display: none;'><a href="slugstring.html#.fill">fill</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#wrap">wrap</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">ServerEventService</h1>
    

    




<section>

<header>
    
        <h2>
        
            ServerEventService
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="ServerEventService"><span class="type-signature"></span>new ServerEventService<span class="signature">(server, route, wait_interval<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements a mechanism to react to events from the server.</p>
<ul>
<li>
<p>A POST service is attached to the given route.</p>
</li>
<li>
<p>This is the server side of a simple <a href="./ServerEvent.html">client</a>/server mechanism for persistent data.</p>
</li>
<li>
<p>The local service is attached to an express web mechanism, using a construct of the form:</p>
</li>
</ul>
<pre class="prettyprint source"><code>// Loads required packages
const express = require(&quot;express&quot;);
const server = express();
const ServerEventService = require(&quot;./ServerEventService.js&quot;);

// Defines a minimal persistantdata service
new ServerEventService(server, &quot;/_serverevent&quot;);
server.listen(8080);
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>server</code></td>
            

            <td class="type">
            
                
<span class="param-type">express</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The express server mechanism.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>route</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>/_serverevent</code>
                
                </td>
            

            <td class="description last"><p>The route, both :</p>
<ul>
<li>The URL route to this service and</li>
<li>The local root directory path.</li>
</ul></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>wait_interval</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>10</code>
                
                </td>
            

            <td class="description last"><p>The waiting interval between scanning the event queue, minimal value is 10.</p></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="~doQuery"><span class="type-signature type-signature-inner">(inner) </span>doQuery<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements the event server management query.
The even server management queries are:</p>
<ul>
<li><code>action=clear</code> :
<ul>
<li>Purges all pending events.</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id="add"><span class="type-signature"></span>add<span class="signature">(value)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Appends an event to the event queue.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>



            
            </td>

            

            

            <td class="description last"><p>The event value, it might be a JSON string.</p></td>
        </tr>

    
    </tbody>
</table>



















        
            

    

    <h4 class="name" id="clear"><span class="type-signature"></span>clear<span class="signature">()</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Clears the event queue.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>






























        
            

    

    <h4 class="name" id="addClock"><span class="type-signature"></span>addClock<span class="signature">(period, count)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Generates a periodic event (mainly for debugging purpose).</p>
<ul>
<li>The event value writes <code>$index</code>, the occurence index, starting from 0.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>period</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The clock period in millisecond, 0 to stop the clock.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>count</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The maximal number of event, 0 if no bound.</p></td>
        </tr>

    
    </tbody>
</table>



















        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>